package com.cicdi.notify;

import com.cicdi.notify.template.Template;
import com.cicdi.notify.template.TemplateManager;

import java.util.Map;

/**
 * @author xueye
 */
public abstract class AbstractNotifier<T extends Template> implements Notifier<T> {

    private final TemplateManager templateManager;

    public AbstractNotifier(TemplateManager templateManager) {
        this.templateManager = templateManager;
    }

    @Override
    public void send(String templateId, Map<String, Object> context) {
        Template template = templateManager.getTemplate(this.getType(), templateId);
        if (null == template) {
            throw new UnsupportedOperationException("模版不存在:" + templateId);
        }
        this.send((T) template, context);
    }
}
