package com.cicdi.notify.wechat;

import com.alibaba.fastjson.JSONObject;
import com.cicdi.notify.*;
import com.cicdi.notify.template.AbstractTemplateManager;
import com.cicdi.notify.template.Template;
import com.cicdi.notify.template.TemplateManager;
import com.cicdi.notify.template.TemplateProperties;
import org.junit.Test;

import java.util.HashMap;
import java.util.Map;

/**
 * @author xueye
 */
public class WechatTest {
    @Test
    public void test() {
        // 通知器配置管理器
        NotifyConfigManager notifyConfigManager = (notifyType, configId) -> {
            NotifierProperties notifierProperties = new NotifierProperties();
            notifierProperties.setType(DefaultNotifyType.wechat.getId());
            notifierProperties.setProvider(WechatProvider.corpMessage.getId());
            notifierProperties.setId("12");

            Map<String, Object> config = new HashMap<>();
            config.put("corpId", "wwbd49ae2419a55a9f");
            config.put("corpSecret", "TXDRQw_H8gpVKX0E01EmwMXJ4VooXmj65I-mDe0wQ1k");

            notifierProperties.setConfiguration(config);

            return notifierProperties;
        };

        // 模板管理器
        TemplateManager templateManager = new AbstractTemplateManager() {
            @Override
            protected TemplateProperties getProperties(NotifyType type, String id) {
                TemplateProperties templateProperties = new TemplateProperties();
                templateProperties.setType(DefaultNotifyType.wechat.getId());
                templateProperties.setProvider(WechatProvider.corpMessage.getId());

                JSONObject jsonObject = new JSONObject();
                jsonObject.put("agentId", "3010084");
                jsonObject.put("toUser", "XueYe");
                jsonObject.put("toParty", "");
                jsonObject.put("toTag", "");
                jsonObject.put("message", "Hello");

                templateProperties.setTemplate(jsonObject.toJSONString());

                return templateProperties;
            }
        };

        NotifierManager notifierManager = new DefaultNotifierManager(notifyConfigManager);

        // register
        WechatNotifierProvider provider = new WechatNotifierProvider(templateManager);
        notifierManager.registerProvider(provider);
        templateManager.register(provider);

        Notifier<Template> notifier = notifierManager.getNotifier(DefaultNotifyType.wechat, "123");
        notifier.send(templateManager.getTemplate(DefaultNotifyType.wechat, "124"), new HashMap<>());
    }
}
